/* Объект асинхронных запросов */
function XmlHttp() {}


/*
Создание XMLHttpRequest-объекта
Возвращает созданный объект или null,
если XMLHttpRequest не поддерживается
*/

if (typeof XMLHttpRequest === 'undefined') {
	try { XmlHttp.XmlHttpObj =  new ActiveXObject("Msxml2.XMLHTTP.6.0"); }
		catch(e) {}
	try { XmlHttp.XmlHttpObj = ActiveXObject("Msxml2.XMLHTTP.3.0"); }
		catch(e) {}
	try { XmlHttp.XmlHttpObj = ActiveXObject("Msxml2.XMLHTTP"); }
		catch(e) {}
	try { XmlHttp.XmlHttpObj = ActiveXObject("Microsoft.XMLHTTP"); }
		catch(e) {}
	throw new Error("This browser does not support XMLHttpRequest.");
}
else
	XmlHttp.XmlHttpObj =  new XMLHttpRequest();


/*
Кодирование данных (простого ассоциативного массива вида { name : value, ...}
в URL-escaped строку (кодировка UTF-8)
*/
XmlHttp.urlEncodeDate = function(data)
{
	var query = [];
	
	if (data instanceof Object)
	{
		for (var k in data)
			query.push(encodeURIComponent(k) + "=" + encodeURIComponent(data[k]));

		return query.join('&');
	}
	else
		return encodeURIComponent(data);
}


/*
Выполнение POST-запроса 
url - адрес запроса
data - параметры в виде простого ассоциативного массива { name : value, ...} 
callback - (не обяз.) callback-функция,	которая будет вызвана после выполнения запроса и получения ответа от сервера
*/
XmlHttp.serverRequest = function(url, data, callback)
{
	var request = this.XmlHttpObj;
	if (!request) return false;

	request.onreadystatechange = function()
	{ 
		if(request.readyState == 4 && callback) callback(request);
	};
	request.open('POST', url, true);

	if (request.setRequestHeader)
		request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
	request.send(XmlHttp.urlEncodeDate(data));

	return true;
}


/* Парсинг URI и вывод инфы */
function parse_uri()
{
	// Готовим URI
	var uri_input = document.getElementById("uri");
	var data = { "uri" : uri_input.value };

	// Вырубаем кнопку сохранения
	var save = document.getElementById("save");
	save.disabled = true;
	
	// Запрашиваем ответ с сервера
	XmlHttp.serverRequest("s/parse_uri.php", data, function(request)
	{
		// Разбираем ответ в объект
		var response = eval("(" + request.responseText + ")");
		
		// Если есть инфа, то выводим её. Иначе - вырубаем кнопку.
		if (response)
		{
			// Информация о URI
			var uri_info = response.uri_info;
			if (uri_info)
				for (var property in uri_info)
					document.getElementById(property).innerHTML = uri_info[property];
			
			// Информация о подключении
			var connection_info = response.connection_info;
			if (connection_info)
			{
				for (var property in connection_info)
					document.getElementById(property).innerHTML = connection_info[property];
				
				// Отображаем таблицу
				var connection_holder = document.getElementById("connection_holder");
				connection_holder.style.display = "block";
			}
			
			// Архивные тесты
			var archive_header = document.getElementById("archive_header");
			var archive = document.getElementById("archive");
			archive_header.style.display = archive.style.display = "block";
			var tests = response.tests;
			archive.innerHTML = tests;
			
			save.disabled = false;
		}
		else
			save.disabled = true;
	});
	
	return false;
}


/* Сохранение результатов теста */
function save_test()
{
	var uri_input = document.getElementById("uri");
	var server = document.getElementById("server").innerHTML;
	var connect_time = document.getElementById("connect_time").innerHTML;
	var document_size = document.getElementById("document_size").innerHTML;
	var speed_download = document.getElementById("speed_download").innerHTML;

	var data =
	{
		"uri" : uri_input.value,
		"server" : server,
		"connect_time" : connect_time,
		"document_size" : document_size,
		"speed_download" : speed_download
	};
	
	XmlHttp.serverRequest("s/save_test.php", data, function(request)
	{
		var test = eval("(" + request.responseText + ")");

		if (test)
		{
			var tests_table = document.getElementById("tests_table")

			if (!tests_table)
			{
				var archive = document.getElementById("archive");
				archive.innerHTML = "";
				var tests_table = document.createElement("table");
				tests_table.className = "db";
				tests_table.id = "tests_table";
				tests_table.setAttribute("cellspacing", 0);
				archive.appendChild(tests_table);
				var header_row = tests_table.insertRow(0);
				header_row.innerHTML = "<th width='180px'>Сохранено</th>\
				<th>ПО сервера</th>\
				<th width='230px'>Время подключения</th>\
				<th width='170px'>Размер документа</th>\
				<th width='180px'>Скорость скачивания</th>";
			}
			var new_row = tests_table.insertRow(1);
			var i = 0;
			for (var property in test)
			{
				var cell = new_row.insertCell(i++);
				cell.innerHTML = test[property];
			}
		}
		else
			alert("Не удалось сохранить тест");
	});
}


/* Инициализация при загрузке документа */
function init()
{
	// Привязка функции save_test к клику по кнопке
	var save = document.getElementById("save");
	save.disabled = true;
	save.onclick = save_test;
	
	// Привязка функции parse_uri к вводу текста в поле
	var uri_input = document.getElementById("uri");
	var uri_form = document.forms["uri_form"];
	uri_form.onsubmit = uri_input.onchange = uri_input.onkeyup = parse_uri;
}