<?php

	require_once "config.php";

	// Готовим URI. Добавляем http://, если протокол не задан явно
	$uri = trim($_POST["uri"]);
	$double_slash_pos = strpos($uri, "://");
	if ($double_slash_pos === false)
		$uri = "http://".$uri;


	// Парсим URI
	$uri_info = parse_url($uri);
	
	
	// Готовим инфу по пунктам
	$scheme = $uri_info["scheme"] ? $uri_info["scheme"] : "http";
	$user = $uri_info["user"] ? $uri_info["user"] : "не задан";
	$pass = $uri_info["pass"] ? $uri_info["pass"] : "не задан";
	$port = $uri_info["port"] ? $uri_info["port"] : 80;
	$path = $uri_info["path"] ? $uri_info["path"] : "не задан";
	$query = $uri_info["query"] ? $uri_info["query"] : "не задан";
	$fragment = $uri_info["fragment"] ? $uri_info["fragment"] : "не задан";
	
	
	
	// Если передан IP, то сначала получаем домен, а потом массив IP-адресов
	if (is_numeric(ip2long($uri_info["host"])))
		$domain = gethostbyaddr($uri_info["host"]);
	else
		$domain = $uri_info["host"];
	$ips = gethostbynamel($domain);
	$host = "<a href=\'http://".$domain."\'>".$domain."</a>";
	if ($ips)
		$host .= "<br>".implode("<br>", $ips);
	
	
	// Получаем параметры соединения
	$ch = curl_init("http://".$domain);
	curl_setopt($ch, CURLOPT_HEADER, true);
	//curl_setopt($ch, CURLOPT_NOBODY, true);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_exec($ch);
	$connection_info = curl_getinfo($ch);
	curl_close($ch);
	
	// Готовим параметры соединения
	$connect_time = $connection_info["connect_time"]." с";
	$speed_download = round($connection_info["speed_download"] / 1000, 3)." Кб/с";
	$document_size = ($connection_info["download_content_length"] > 0) ? round($connection_info["download_content_length"] / 1000, 3)." Кб" : "не доступно";
	
	// Готовим инфу по серверу
	$server_response = get_headers("http://".$domain, 1);
	$server = $server_response["Server"] ? $server_response["Server"] : "скрыта";
	// Если строка сервера получилась массивом
	if (is_array($server))
		$server = implode(", ", array_unique($server));
	
	
	// Получем инфу о прежних теста
	$query_select_domain = mysql_query("
	SELECT
		id_domain
	FROM
		web_tester_domains
	WHERE
		domain = '".$domain."'");

	if (mysql_num_rows($query_select_domain))
	{
		// Добываем тесты
		$id_domain = mysql_result($query_select_domain, 0);
		$query_select_tests = mysql_query("
		SELECT
			UNIX_TIMESTAMP(time) AS time,
			connect_time,
			speed_download,
			document_size,
			server
		FROM
			web_tester_tests
		WHERE
			id_domain = ".$id_domain."
		ORDER BY
			time DESC");
		
		// Пишем тесты в переменную
		$tests = "\\
		<table cellspacing=\'0\' class=\'db\' id=\'tests_table\'>\\
		<tr>\\
			<th width=\'180px\'>Сохранено</th>\\
			<th>ПО сервера</th>\\
			<th width=\'230px\'>Время подключения</th>\\
			<th width=\'170px\'>Размер документа</th>\\
			<th width=\'180px\'>Скорость скачивания</th>\\
		</tr>";
		while ($rows = mysql_fetch_array($query_select_tests))
		{
			$tests .= "\\
			<tr>\\
				<td>".date("d.m.Y H:i:s", $rows["time"])."</td>\\
				<td>".$rows["server"]."</td>\\
				<td>".$rows["connect_time"]."</td>\\
				<td>".$rows["document_size"]."</td>\\
				<td>".$rows["speed_download"]."</td>\\
			</tr>";
		}
		$tests .= "</table>";
	}
	else
	{
		$tests = "Для домена «".$domain."» нет сохраненных тестов.";
	}
	
	// Выводим информацию в JSON-формате
	if ($ips)
		echo "
		{
			'uri_info' :
			{
				'scheme' : '".$scheme."',
				'user' : '".$user."',
				'pass' : '".$pass."',
				'port' : '".$port."',
				'path' : '".$path."',
				'query' : '".$query."',
				'fragment' : '".$fragment."',
				'host' : '".$host."'
			},
			
			'connection_info' :
			{
				'server' : '".$server."',
				'connect_time' : '".$connect_time."',
				'speed_download' : '".$speed_download."',
				'document_size' : '".$document_size."'
			},
			
			'tests' : '".$tests."'
		}";
	else
		echo "false";

?>